:: Script zur unbeaufsichtigte SHP-Mandantensicherung
:: Erstellt von Thomas Ludwig - https://Ludwig-Neukirchen.de
:: Download unter https://ludwig-neukirchen.de/downloads/shpbackup.7z
:: ------------------------------------------------------------------
@echo off
:: ---- Variablen setzen ----
:: ---- Backup-Pfad
SET BackupRoot=C:\PGDB_Backup
:: ---- Datenbankname - Standard = BSS_DATA_SHP
SET Datenbank=BSS_DATA_SHP
:: ---- Der zu sichernde Mandant - hier 00001
SET Schema=00001
:: ---- EMail-Einstellungen
SET MailFrom=info@ludwig-neukirchen.de
SET MailTo=tl@ludwig-neukirchen.de   
SET MailUser=info@ludwig-neukirchen.de
SET MailServer=ludwig-neukirchen.de
SET MailPassword=Hj80ix5*6  
:: ---- Zeitstempel fr Anfang zusammenbauen
SET Tag=%date:~0,2%
SET Monat=%date:~3,2%
SET Jahr=%date:~6,4%
SET hh=%time:~0,2%
SET mm=%time:~3,2%
SET Zeitstempel=%Jahr%-%Monat%-%Tag%_%hh%-%mm%
:: ---- Fhrende Nullen einfgen
:: Quelle: https://znil.net/index.php/Windows:Batch_/_DOS-Box:_aktuelles_Datum_und_Uhrzeit_f%C3%BCr_Datei-_oder_Verzeichnisnamen_verwenden
setlocal enabledelayedexpansion
set Zeitstempel=!Zeitstempel:^ =0!
setlocal disabledelayedexpansion
:: ---- Ordner mit Tagesdatum wird erstellt und an Backup-Pfad angehngt
SET Tagesordner=%BackupRoot%\%Jahr%-%Monat%-%Tag%
mkdir %Tagesordner% 
:: ---- Backup- und Log-Dateinamen erstellen
SET BackupDatei=%Tagesordner%\Backup_%Schema%_%Zeitstempel%.sql
SET LogDatei=%Tagesordner%\Backup_%Schema%_%Zeitstempel%.log
:: ---- Sicherungsstart ins Log eintragen
echo Start der Sicherung: %Zeitstempel% > %LogDatei%
echo Sichere Mandant %Schema% >> %LogDatei%
:: Datenbank-Passwort --> Besser in %APPDATA%\postgresql\pgpass.conf  einrichten - Siehe Doku
:: SET PGPASSWORD=

:: ---- Backup ausfhren
"C:\Program Files\PostgreSQL\16\bin\pg_dump.exe" -h localhost -p 5432 -U hwowner -F c -b -Z 9 -C -v --inserts --column-inserts -E UTF8 --schema %Schema% -f %BackupDatei% %Datenbank% 1>> %LogDatei% 2>&1
SET Result=%ERRORLEVEL%
@echo off
:: ---- Zeitstempel fr Endzeit zusammenbauen
SET Tag=%date:~0,2%
SET Monat=%date:~3,2%
SET Jahr=%date:~6,4%
SET hh=%time:~0,2%
SET mm=%time:~3,2%
SET Zeitstempel=%Jahr%-%Monat%-%Tag%_%hh%-%mm%
:: ---- Fhrende Nullen einfgen
:: Quelle: https://znil.net/index.php/Windows:Batch_/_DOS-Box:_aktuelles_Datum_und_Uhrzeit_f%C3%BCr_Datei-_oder_Verzeichnisnamen_verwenden
setlocal enabledelayedexpansion
set Zeitstempel=!Zeitstempel:^ =0!
setlocal disabledelayedexpansion
echo Ende der Sicherung: %Zeitstempel% >> %LogDatei%
:: ---- Verlauf protokollieren
IF %Result% EQU 0 ( 
         echo Backup von Mandant %Schema% Erfolgreich  >> %LogDatei%
         set Status=Backup von Mandant %Schema% Erfolgreich
) ELSE (
   echo Backup Fehler 
   SET Status=Backup von Mandant %Schema% fehlgeschlagen Fehler = %Result%
   )
:: ---- BSS_GLOBAL sichern
echo Sichere BSS_GLOBAL >> %LogDatei%
SET Schema="\"BSS_GLOBAL\""
SET BackupDatei=%Tagesordner%\Backup_BSS_GLOBAL_%Zeitstempel%.sql
"C:\Program Files\PostgreSQL\16\bin\pg_dump.exe" -h localhost -p 5432 -U hwowner -F c -b -Z 9 -C -v --inserts --column-inserts -E UTF8 --schema %Schema% -f %BackupDatei% %Datenbank% 1>> %LogDatei% 2>&1
:: ---- Sicherungsstatus ins Protokoll schreiben
IF %ERRORLEVEL% EQU 0 ( 
         echo Backup BSS_GLOBAL Erfolgreich >> %LogDatei%
         set StatusG=Backup von BSS_GLOBAL Erfolgreich
) ELSE (
   echo Backup Fehler bei BSS_GLOBAL  >> %LogDatei%
   SET StatusG=Backup von BSS_GLOBAL -  fehlgeschlagen Fehler = %ERRORLEVEL%
   )
:: ---- EMail versenden  
c:\tools\mailsend.exe -f %MailFrom% -smtp %MailServer% -auth -user %MailUser% -pass %MailPassword% -t %MailTo% -sub "%Status%" -M "%Status% - %StatusG%" -cs "iso-8859-1" -attach,a %LogDatei%
:: ---- Alte Backup's nach 7 Tagen lschen
FORFILES /p %BackupRoot% /S /D -7 /C "cmd /c IF @isdir == TRUE RMDIR /S /Q @path"
SET Result=%ERRORLEVEL%
IF %Result% EQU 0 ( 
   echo Directory lter als 7 Tage wurden gelscht  >> %LogDatei% 
) ELSE (
   echo Keine Daten zum Loeschen gefunden  >> %LogDatei%
   )   
